From 528ea7170c26192872f4b444cd687afd224ff962 Mon Sep 17 00:00:00 2001
From: Thomas NOEL <tnoel@entrouvert.com>
Date: Fri, 14 Dec 2018 14:33:59 +0100
Subject: [PATCH] minint: finish css re-organization (#29068)

---
 static/minint/{css => }/img/bg-header.png     | Bin
 static/minint/{css => }/img/bullet.png        | Bin
 static/minint/{css => }/img/chevron-back.png  | Bin
 static/minint/{css => }/img/chevron.png       | Bin
 static/minint/{css => }/img/chevron_white.png | Bin
 static/minint/{css => }/img/ico-arrow-top.png | Bin
 static/minint/{css => }/img/ico-download.png  | Bin
 .../{css => }/img/ico-link-external.png       | Bin
 static/minint/{css => }/img/ico-mailto.png    | Bin
 static/minint/{css => }/img/picto-alert.png   | Bin
 static/minint/{css => }/img/picto-valid.png   | Bin
 static/minint/sass/_fontface.scss             |  30 +++++++++---------
 templates/variants/minint/theme.html          |   2 +-
 13 files changed, 16 insertions(+), 16 deletions(-)
 rename static/minint/{css => }/img/bg-header.png (100%)
 rename static/minint/{css => }/img/bullet.png (100%)
 rename static/minint/{css => }/img/chevron-back.png (100%)
 rename static/minint/{css => }/img/chevron.png (100%)
 rename static/minint/{css => }/img/chevron_white.png (100%)
 rename static/minint/{css => }/img/ico-arrow-top.png (100%)
 rename static/minint/{css => }/img/ico-download.png (100%)
 rename static/minint/{css => }/img/ico-link-external.png (100%)
 rename static/minint/{css => }/img/ico-mailto.png (100%)
 rename static/minint/{css => }/img/picto-alert.png (100%)
 rename static/minint/{css => }/img/picto-valid.png (100%)

diff --git a/static/minint/css/img/bg-header.png b/static/minint/img/bg-header.png
similarity index 100%
rename from static/minint/css/img/bg-header.png
rename to static/minint/img/bg-header.png
diff --git a/static/minint/css/img/bullet.png b/static/minint/img/bullet.png
similarity index 100%
rename from static/minint/css/img/bullet.png
rename to static/minint/img/bullet.png
diff --git a/static/minint/css/img/chevron-back.png b/static/minint/img/chevron-back.png
similarity index 100%
rename from static/minint/css/img/chevron-back.png
rename to static/minint/img/chevron-back.png
diff --git a/static/minint/css/img/chevron.png b/static/minint/img/chevron.png
similarity index 100%
rename from static/minint/css/img/chevron.png
rename to static/minint/img/chevron.png
diff --git a/static/minint/css/img/chevron_white.png b/static/minint/img/chevron_white.png
similarity index 100%
rename from static/minint/css/img/chevron_white.png
rename to static/minint/img/chevron_white.png
diff --git a/static/minint/css/img/ico-arrow-top.png b/static/minint/img/ico-arrow-top.png
similarity index 100%
rename from static/minint/css/img/ico-arrow-top.png
rename to static/minint/img/ico-arrow-top.png
diff --git a/static/minint/css/img/ico-download.png b/static/minint/img/ico-download.png
similarity index 100%
rename from static/minint/css/img/ico-download.png
rename to static/minint/img/ico-download.png
diff --git a/static/minint/css/img/ico-link-external.png b/static/minint/img/ico-link-external.png
similarity index 100%
rename from static/minint/css/img/ico-link-external.png
rename to static/minint/img/ico-link-external.png
diff --git a/static/minint/css/img/ico-mailto.png b/static/minint/img/ico-mailto.png
similarity index 100%
rename from static/minint/css/img/ico-mailto.png
rename to static/minint/img/ico-mailto.png
diff --git a/static/minint/css/img/picto-alert.png b/static/minint/img/picto-alert.png
similarity index 100%
rename from static/minint/css/img/picto-alert.png
rename to static/minint/img/picto-alert.png
diff --git a/static/minint/css/img/picto-valid.png b/static/minint/img/picto-valid.png
similarity index 100%
rename from static/minint/css/img/picto-valid.png
rename to static/minint/img/picto-valid.png
diff --git a/static/minint/sass/_fontface.scss b/static/minint/sass/_fontface.scss
index 3d1d054c..9ac164ab 100644
--- a/static/minint/sass/_fontface.scss
+++ b/static/minint/sass/_fontface.scss
@@ -13,33 +13,33 @@
 
 @font-face {
   font-family: 'robotoslab_light';
-  src: url('../webfonts/robotoslab/RobotoSlab-Light-webfont.eot');
-  src: url('../webfonts/robotoslab/RobotoSlab-Light-webfont.eot?#iefix') format('embedded-opentype'),
-       url('../webfonts/robotoslab/RobotoSlab-Light.woff') format('woff'),
-       url('../webfonts/robotoslab/RobotoSlab-Light-webfont.ttf') format('truetype'),
-       url('../webfonts/robotoslab/RobotoSlab-Light-webfont.svg#robotoslab_light') format('svg');
+  src: url('webfonts/robotoslab/RobotoSlab-Light-webfont.eot');
+  src: url('webfonts/robotoslab/RobotoSlab-Light-webfont.eot?#iefix') format('embedded-opentype'),
+       url('webfonts/robotoslab/RobotoSlab-Light.woff') format('woff'),
+       url('webfonts/robotoslab/RobotoSlab-Light-webfont.ttf') format('truetype'),
+       url('webfonts/robotoslab/RobotoSlab-Light-webfont.svg#robotoslab_light') format('svg');
   font-weight: 300;
   font-style: normal;
 }
 
 @font-face {
   font-family: 'robotoslab_regular';
-  src: url('../webfonts/robotoslab/RobotoSlab-Regular-webfont.eot');
-  src: url('../webfonts/robotoslab/RobotoSlab-Regular-webfont.eot?#iefix') format('embedded-opentype'),
-       url('../webfonts/robotoslab/RobotoSlab-Regular.woff') format('woff'),
-       url('../webfonts/robotoslab/RobotoSlab-Regular-webfont.ttf') format('truetype'),
-       url('../webfonts/robotoslab/RobotoSlab-Regular-webfont.svg#robotoslab_regular') format('svg');
+  src: url('webfonts/robotoslab/RobotoSlab-Regular-webfont.eot');
+  src: url('webfonts/robotoslab/RobotoSlab-Regular-webfont.eot?#iefix') format('embedded-opentype'),
+       url('webfonts/robotoslab/RobotoSlab-Regular.woff') format('woff'),
+       url('webfonts/robotoslab/RobotoSlab-Regular-webfont.ttf') format('truetype'),
+       url('webfonts/robotoslab/RobotoSlab-Regular-webfont.svg#robotoslab_regular') format('svg');
   font-weight: 400;
   font-style: normal;
 }
 
 @font-face {
   font-family: 'robotoslab_bold';
-  src: url('../webfonts/robotoslab/RobotoSlab-Bold-webfont.eot');
-  src: url('../webfonts/robotoslab/RobotoSlab-Bold-webfont.eot?#iefix') format('embedded-opentype'),
-       url('../webfonts/robotoslab/RobotoSlab-Bold.woff') format('woff'),
-       url('../webfonts/robotoslab/RobotoSlab-Bold-webfont.ttf') format('truetype'),
-       url('../webfonts/robotoslab/RobotoSlab-Bold-webfont.svg#robotoslab_bold') format('svg');
+  src: url('webfonts/robotoslab/RobotoSlab-Bold-webfont.eot');
+  src: url('webfonts/robotoslab/RobotoSlab-Bold-webfont.eot?#iefix') format('embedded-opentype'),
+       url('webfonts/robotoslab/RobotoSlab-Bold.woff') format('woff'),
+       url('webfonts/robotoslab/RobotoSlab-Bold-webfont.ttf') format('truetype'),
+       url('webfonts/robotoslab/RobotoSlab-Bold-webfont.svg#robotoslab_bold') format('svg');
   font-weight: 700;
   font-style: normal;
 }
diff --git a/templates/variants/minint/theme.html b/templates/variants/minint/theme.html
index a311482b..5116799e 100644
--- a/templates/variants/minint/theme.html
+++ b/templates/variants/minint/theme.html
@@ -62,7 +62,7 @@
   {% block extra_scripts %}
   {% endblock %}
 
-  <link href="{{site_base}}{% static "" %}minint/css/styles.css" rel="stylesheet">
+  <link href="{{site_base}}{% static "" %}minint/style.css" rel="stylesheet">
 
     <!-- respond.js enable media query support -->
   <!--[if lt IE 9]>
-- 
2.19.2